> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/compute/zec/qos-policy-group/addqospolicygroupmembers.md).

# AddQosPolicyGroupMembers

## 1. API Description

This API (AddQosPolicyGroupMembers) is used to add EIPs, IPv6 addresses, or UNMANAGED egress IPs to a QoS policy group.

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name   | Required | Type                                                                                              | Description                                 |
| ---------------- | -------- | ------------------------------------------------------------------------------------------------- | ------------------------------------------- |
| qosPolicyGroupId | Yes      | String                                                                                            | QoS policy group ID.                        |
| members          | Yes      | Array of [QosPolicyGroupMember](/api-reference/compute/zec/datastructure.md#qospolicygroupmember) | List of members to add to the policy group. |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**1. Add members to a QoS policy group.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: AddQosPolicyGroupMembers
<Common Request Params>

Request：
{
  "qosPolicyGroupId": "qos-xxxxxxxx",
  "members": [
    {
      "resourceId": "eip-xxxxxxxx",
      "ipType": "Eip"
    },
    {
      "resourceId": "ipv6-xxxxxxxx",
      "ipType": "Ipv6"
    }
  ]
}

Response：
{
  "requestId": "TEEFDCA5B-76FB-4E91-A18E-DF7F5D2CE41F",
  "response": {
    "requestId": "TEEFDCA5B-76FB-4E91-A18E-DF7F5D2CE41F"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                                | Description                                                                                                                                   |
| ---------------- | ----------------------------------------- | --------------------------------------------------------------------------------------------------------------------------------------------- |
| 404              | INVALID\_QOS\_POLICY\_GROUP\_NOT\_FOUND   | The QoS policy group does not exist.                                                                                                          |
| 409              | INVALID\_RESOURCE\_ALREADY\_IN\_GROUP     | The resource is already in another policy group.                                                                                              |
| 400              | INVALID\_RESOURCE\_TYPE\_INVALID          | The resource type is not supported.                                                                                                           |
| 400              | INVALID\_RESOURCE\_REGION\_MISMATCH       | The resource is in a different region and cannot be added to the policy group.                                                                |
| 400              | INVALID\_RESOURCE\_STATUS\_NOT\_AVAILABLE | The current resource status does not support joining a policy group. Only resources in a stable state (bound or unbound) are allowed to join. |
